VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CBitCalc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'
' Wrapper class for bit calculation functions exported by ntdll.dll. This class provides
' functionality for integer calculating and bit-shifting without overflows and the use of native
' VB functions.
'
Option Explicit

Private Declare Function ShiftLeft Lib "ntdll.dll" Alias "RtlLargeIntegerShiftLeft" (ByVal Val1 As Long, ByVal Val2 As Long, ByVal ShiftCount As Long) As LARGE_INTEGER
Private Declare Function ShiftRight Lib "ntdll.dll" Alias "RtlLargeIntegerShiftRight" (ByVal Val1 As Long, ByVal Val2 As Long, ByVal ShiftCount As Long) As LARGE_INTEGER
Private Declare Function RealAdd Lib "ntdll.dll" Alias "RtlLargeIntegerAdd" (ByVal Val1a As Long, ByVal Val1b As Long, ByVal Val2a As Long, ByVal Val2b As Long) As LARGE_INTEGER
Private Declare Function RealMultiply Lib "ntdll.dll" Alias "RtlEnlargedUnsignedMultiply" (ByVal Val1 As Long, ByVal Val2 As Long) As LARGE_INTEGER

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private m_liResult As LARGE_INTEGER

Public Function Add(ByVal Number1 As Long, ByVal Number2 As Long) As Long
    m_liResult = RealAdd(Number1, 0&, Number2, 0&)
    Add = m_liResult.lowpart
End Function

Public Function Multiply(ByVal Number1 As Long, ByVal Number2 As Long) As Long
    m_liResult = RealMultiply(Number1, Number2)
    Multiply = m_liResult.lowpart
End Function

Public Function LShift(ByVal Number As Long, ByVal ShiftCount As Long) As Long
    m_liResult = ShiftLeft(Number, 0&, ShiftCount)
    LShift = m_liResult.lowpart
End Function

Public Function RShift(ByVal Number As Long, ByVal ShiftCount As Long) As Long
    m_liResult = ShiftRight(Number, 0&, ShiftCount)
    RShift = m_liResult.lowpart
End Function
